#include <Panel.h>

#define W 16
#define H 16
#define LED_PIN 6

Panel panel(LED_PIN, W, H, SERPENTINE, RIGHT, 0);

#define rgb(R,G,B) panel.color(R,G,B)
#define G rgb(255, 0, 0)
#define R rgb(0, 255, 0)
#define B rgb(0, 0, 255)
#define Z rgb(0, 0, 0)

const uint32_t house_mat[16][16] = 
{
          {
            rgb(255, 255, 0),  // x = 0 ; y = 0
            rgb(255, 255, 0),  // x = 1 ; y = 0
            rgb(0, 185, 252),  // x = 2 ; y = 0
            rgb(0, 185, 252),  // x = 3 ; y = 0
            rgb(0, 185, 252),  // x = 4 ; y = 0
            rgb(0, 185, 252),  // x = 5 ; y = 0
            rgb(0, 185, 252),  // x = 6 ; y = 0
            rgb(0, 185, 252),  // x = 7 ; y = 0
            rgb(0, 185, 252),  // x = 8 ; y = 0
            rgb(0, 185, 252),  // x = 9 ; y = 0
            rgb(0, 185, 252),  // x = 10 ; y = 0
            rgb(0, 185, 252),  // x = 11 ; y = 0
            rgb(0, 185, 252),  // x = 12 ; y = 0
            rgb(0, 185, 252),  // x = 13 ; y = 0
            rgb(0, 185, 252),  // x = 14 ; y = 0
            rgb(0, 185, 252)  // x = 15 ; y = 0
          },
          {
            rgb(255, 255, 0),  // x = 0 ; y = 1
            rgb(255, 255, 0),  // x = 1 ; y = 1
            rgb(0, 185, 252),  // x = 2 ; y = 1
            rgb(0, 185, 252),  // x = 3 ; y = 1
            rgb(0, 185, 252),  // x = 4 ; y = 1
            rgb(0, 185, 252),  // x = 5 ; y = 1
            rgb(0, 185, 252),  // x = 6 ; y = 1
            rgb(0, 185, 252),  // x = 7 ; y = 1
            rgb(0, 185, 252),  // x = 8 ; y = 1
            rgb(0, 185, 252),  // x = 9 ; y = 1
            rgb(0, 185, 252),  // x = 10 ; y = 1
            rgb(0, 185, 252),  // x = 11 ; y = 1
            rgb(0, 185, 252),  // x = 12 ; y = 1
            rgb(0, 185, 252),  // x = 13 ; y = 1
            rgb(0, 185, 252),  // x = 14 ; y = 1
            rgb(0, 185, 252)  // x = 15 ; y = 1
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 2
            rgb(0, 185, 252),  // x = 1 ; y = 2
            rgb(0, 185, 252),  // x = 2 ; y = 2
            rgb(0, 185, 252),  // x = 3 ; y = 2
            rgb(0, 185, 252),  // x = 4 ; y = 2
            rgb(0, 185, 252),  // x = 5 ; y = 2
            rgb(0, 185, 252),  // x = 6 ; y = 2
            rgb(0, 185, 252),  // x = 7 ; y = 2
            rgb(0, 185, 252),  // x = 8 ; y = 2
            rgb(0, 185, 252),  // x = 9 ; y = 2
            rgb(0, 185, 252),  // x = 10 ; y = 2
            rgb(0, 185, 252),  // x = 11 ; y = 2
            rgb(119, 119, 121),  // x = 12 ; y = 2
            rgb(119, 119, 121),  // x = 13 ; y = 2
            rgb(0, 185, 252),  // x = 14 ; y = 2
            rgb(0, 185, 252)  // x = 15 ; y = 2
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 3
            rgb(0, 185, 252),  // x = 1 ; y = 3
            rgb(0, 185, 252),  // x = 2 ; y = 3
            rgb(0, 185, 252),  // x = 3 ; y = 3
            rgb(0, 185, 252),  // x = 4 ; y = 3
            rgb(0, 185, 252),  // x = 5 ; y = 3
            rgb(0, 185, 252),  // x = 6 ; y = 3
            rgb(0, 185, 252),  // x = 7 ; y = 3
            rgb(0, 185, 252),  // x = 8 ; y = 3
            rgb(0, 185, 252),  // x = 9 ; y = 3
            rgb(0, 185, 252),  // x = 10 ; y = 3
            rgb(119, 119, 121),  // x = 11 ; y = 3
            rgb(119, 119, 121),  // x = 12 ; y = 3
            rgb(0, 185, 252),  // x = 13 ; y = 3
            rgb(0, 185, 252),  // x = 14 ; y = 3
            rgb(0, 185, 252)  // x = 15 ; y = 3
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 4
            rgb(0, 185, 252),  // x = 1 ; y = 4
            rgb(0, 185, 252),  // x = 2 ; y = 4
            rgb(0, 185, 252),  // x = 3 ; y = 4
            rgb(0, 185, 252),  // x = 4 ; y = 4
            rgb(0, 185, 252),  // x = 5 ; y = 4
            rgb(0, 185, 252),  // x = 6 ; y = 4
            rgb(0, 185, 252),  // x = 7 ; y = 4
            rgb(0, 185, 252),  // x = 8 ; y = 4
            rgb(0, 185, 252),  // x = 9 ; y = 4
            rgb(0, 185, 252),  // x = 10 ; y = 4
            rgb(252, 139, 0),  // x = 11 ; y = 4
            rgb(0, 185, 252),  // x = 12 ; y = 4
            rgb(0, 185, 252),  // x = 13 ; y = 4
            rgb(0, 185, 252),  // x = 14 ; y = 4
            rgb(0, 185, 252)  // x = 15 ; y = 4
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 5
            rgb(0, 185, 252),  // x = 1 ; y = 5
            rgb(0, 185, 252),  // x = 2 ; y = 5
            rgb(126, 70, 0),  // x = 3 ; y = 5
            rgb(126, 70, 0),  // x = 4 ; y = 5
            rgb(126, 70, 0),  // x = 5 ; y = 5
            rgb(126, 70, 0),  // x = 6 ; y = 5
            rgb(126, 70, 0),  // x = 7 ; y = 5
            rgb(126, 70, 0),  // x = 8 ; y = 5
            rgb(126, 70, 0),  // x = 9 ; y = 5
            rgb(126, 70, 0),  // x = 10 ; y = 5
            rgb(252, 139, 0),  // x = 11 ; y = 5
            rgb(126, 70, 0),  // x = 12 ; y = 5
            rgb(126, 70, 0),  // x = 13 ; y = 5
            rgb(0, 185, 252),  // x = 14 ; y = 5
            rgb(0, 185, 252)  // x = 15 ; y = 5
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 6
            rgb(0, 185, 252),  // x = 1 ; y = 6
            rgb(0, 185, 252),  // x = 2 ; y = 6
            rgb(126, 70, 0),  // x = 3 ; y = 6
            rgb(126, 70, 0),  // x = 4 ; y = 6
            rgb(126, 70, 0),  // x = 5 ; y = 6
            rgb(126, 70, 0),  // x = 6 ; y = 6
            rgb(126, 70, 0),  // x = 7 ; y = 6
            rgb(126, 70, 0),  // x = 8 ; y = 6
            rgb(126, 70, 0),  // x = 9 ; y = 6
            rgb(126, 70, 0),  // x = 10 ; y = 6
            rgb(126, 70, 0),  // x = 11 ; y = 6
            rgb(126, 70, 0),  // x = 12 ; y = 6
            rgb(126, 70, 0),  // x = 13 ; y = 6
            rgb(0, 185, 252),  // x = 14 ; y = 6
            rgb(0, 185, 252)  // x = 15 ; y = 6
          },
          {
            rgb(0, 185, 252),  // x = 0 ; y = 7
            rgb(0, 185, 252),  // x = 1 ; y = 7
            rgb(0, 185, 252),  // x = 2 ; y = 7
            rgb(252, 139, 0),  // x = 3 ; y = 7
            rgb(252, 139, 0),  // x = 4 ; y = 7
            rgb(252, 139, 0),  // x = 5 ; y = 7
            rgb(252, 139, 0),  // x = 6 ; y = 7
            rgb(252, 139, 0),  // x = 7 ; y = 7
            rgb(252, 139, 0),  // x = 8 ; y = 7
            rgb(252, 139, 0),  // x = 9 ; y = 7
            rgb(252, 139, 0),  // x = 10 ; y = 7
            rgb(252, 139, 0),  // x = 11 ; y = 7
            rgb(252, 139, 0),  // x = 12 ; y = 7
            rgb(252, 139, 0),  // x = 13 ; y = 7
            rgb(0, 185, 252),  // x = 14 ; y = 7
            rgb(0, 185, 252)  // x = 15 ; y = 7
          },
          {
            rgb(2, 175, 69),  // x = 0 ; y = 8
            rgb(0, 185, 252),  // x = 1 ; y = 8
            rgb(0, 185, 252),  // x = 2 ; y = 8
            rgb(252, 139, 0),  // x = 3 ; y = 8
            rgb(97, 212, 250),  // x = 4 ; y = 8
            rgb(97, 212, 250),  // x = 5 ; y = 8
            rgb(252, 139, 0),  // x = 6 ; y = 8
            rgb(252, 139, 0),  // x = 7 ; y = 8
            rgb(252, 139, 0),  // x = 8 ; y = 8
            rgb(252, 139, 0),  // x = 9 ; y = 8
            rgb(252, 139, 0),  // x = 10 ; y = 8
            rgb(97, 212, 250),  // x = 11 ; y = 8
            rgb(97, 212, 250),  // x = 12 ; y = 8
            rgb(252, 139, 0),  // x = 13 ; y = 8
            rgb(0, 185, 252),  // x = 14 ; y = 8
            rgb(0, 185, 252)  // x = 15 ; y = 8
          },
          {
            rgb(2, 175, 69),  // x = 0 ; y = 9
            rgb(2, 175, 69),  // x = 1 ; y = 9
            rgb(0, 185, 252),  // x = 2 ; y = 9
            rgb(252, 139, 0),  // x = 3 ; y = 9
            rgb(97, 212, 250),  // x = 4 ; y = 9
            rgb(97, 212, 250),  // x = 5 ; y = 9
            rgb(252, 139, 0),  // x = 6 ; y = 9
            rgb(252, 139, 0),  // x = 7 ; y = 9
            rgb(252, 139, 0),  // x = 8 ; y = 9
            rgb(252, 139, 0),  // x = 9 ; y = 9
            rgb(252, 139, 0),  // x = 10 ; y = 9
            rgb(97, 212, 250),  // x = 11 ; y = 9
            rgb(97, 212, 250),  // x = 12 ; y = 9
            rgb(252, 139, 0),  // x = 13 ; y = 9
            rgb(0, 185, 252),  // x = 14 ; y = 9
            rgb(0, 185, 252)  // x = 15 ; y = 9
          },
          {
            rgb(2, 175, 69),  // x = 0 ; y = 10
            rgb(2, 175, 69),  // x = 1 ; y = 10
            rgb(0, 185, 252),  // x = 2 ; y = 10
            rgb(252, 139, 0),  // x = 3 ; y = 10
            rgb(252, 139, 0),  // x = 4 ; y = 10
            rgb(252, 139, 0),  // x = 5 ; y = 10
            rgb(252, 139, 0),  // x = 6 ; y = 10
            rgb(252, 139, 0),  // x = 7 ; y = 10
            rgb(252, 139, 0),  // x = 8 ; y = 10
            rgb(252, 139, 0),  // x = 9 ; y = 10
            rgb(252, 139, 0),  // x = 10 ; y = 10
            rgb(252, 139, 0),  // x = 11 ; y = 10
            rgb(252, 139, 0),  // x = 12 ; y = 10
            rgb(252, 139, 0),  // x = 13 ; y = 10
            rgb(0, 185, 252),  // x = 14 ; y = 10
            rgb(0, 185, 252)  // x = 15 ; y = 10
          },
          {
            rgb(126, 70, 0),  // x = 0 ; y = 11
            rgb(0, 185, 252),  // x = 1 ; y = 11
            rgb(0, 185, 252),  // x = 2 ; y = 11
            rgb(252, 139, 0),  // x = 3 ; y = 11
            rgb(252, 139, 0),  // x = 4 ; y = 11
            rgb(252, 139, 0),  // x = 5 ; y = 11
            rgb(252, 139, 0),  // x = 6 ; y = 11
            rgb(252, 139, 0),  // x = 7 ; y = 11
            rgb(252, 139, 0),  // x = 8 ; y = 11
            rgb(252, 139, 0),  // x = 9 ; y = 11
            rgb(252, 139, 0),  // x = 10 ; y = 11
            rgb(252, 139, 0),  // x = 11 ; y = 11
            rgb(252, 139, 0),  // x = 12 ; y = 11
            rgb(252, 139, 0),  // x = 13 ; y = 11
            rgb(0, 185, 252),  // x = 14 ; y = 11
            rgb(0, 185, 252)  // x = 15 ; y = 11
          },
          {
            rgb(126, 70, 0),  // x = 0 ; y = 12
            rgb(0, 185, 252),  // x = 1 ; y = 12
            rgb(0, 185, 252),  // x = 2 ; y = 12
            rgb(252, 139, 0),  // x = 3 ; y = 12
            rgb(252, 139, 0),  // x = 4 ; y = 12
            rgb(252, 139, 0),  // x = 5 ; y = 12
            rgb(252, 139, 0),  // x = 6 ; y = 12
            rgb(252, 139, 0),  // x = 7 ; y = 12
            rgb(252, 139, 0),  // x = 8 ; y = 12
            rgb(252, 139, 0),  // x = 9 ; y = 12
            rgb(252, 139, 0),  // x = 10 ; y = 12
            rgb(252, 139, 0),  // x = 11 ; y = 12
            rgb(252, 139, 0),  // x = 12 ; y = 12
            rgb(252, 139, 0),  // x = 13 ; y = 12
            rgb(0, 185, 252),  // x = 14 ; y = 12
            rgb(0, 185, 252)  // x = 15 ; y = 12
          },
          {
            rgb(126, 70, 0),  // x = 0 ; y = 13
            rgb(0, 185, 252),  // x = 1 ; y = 13
            rgb(0, 185, 252),  // x = 2 ; y = 13
            rgb(252, 139, 0),  // x = 3 ; y = 13
            rgb(252, 139, 0),  // x = 4 ; y = 13
            rgb(252, 139, 0),  // x = 5 ; y = 13
            rgb(252, 139, 0),  // x = 6 ; y = 13
            rgb(126, 70, 0),  // x = 7 ; y = 13
            rgb(126, 70, 0),  // x = 8 ; y = 13
            rgb(126, 70, 0),  // x = 9 ; y = 13
            rgb(252, 139, 0),  // x = 10 ; y = 13
            rgb(252, 139, 0),  // x = 11 ; y = 13
            rgb(252, 139, 0),  // x = 12 ; y = 13
            rgb(252, 139, 0),  // x = 13 ; y = 13
            rgb(0, 185, 252),  // x = 14 ; y = 13
            rgb(0, 185, 252)  // x = 15 ; y = 13
          },
          {
            rgb(126, 70, 0),  // x = 0 ; y = 14
            rgb(0, 185, 252),  // x = 1 ; y = 14
            rgb(0, 185, 252),  // x = 2 ; y = 14
            rgb(252, 139, 0),  // x = 3 ; y = 14
            rgb(252, 139, 0),  // x = 4 ; y = 14
            rgb(252, 139, 0),  // x = 5 ; y = 14
            rgb(252, 139, 0),  // x = 6 ; y = 14
            rgb(126, 70, 0),  // x = 7 ; y = 14
            rgb(126, 70, 0),  // x = 8 ; y = 14
            rgb(126, 70, 0),  // x = 9 ; y = 14
            rgb(252, 139, 0),  // x = 10 ; y = 14
            rgb(252, 139, 0),  // x = 11 ; y = 14
            rgb(252, 139, 0),  // x = 12 ; y = 14
            rgb(252, 139, 0),  // x = 13 ; y = 14
            rgb(0, 185, 252),  // x = 14 ; y = 14
            rgb(0, 185, 252)  // x = 15 ; y = 14
          },
          {
            rgb(126, 70, 0),  // x = 0 ; y = 15
            rgb(2, 175, 69),  // x = 1 ; y = 15
            rgb(2, 175, 69),  // x = 2 ; y = 15
            rgb(252, 139, 0),  // x = 3 ; y = 15
            rgb(252, 139, 0),  // x = 4 ; y = 15
            rgb(252, 139, 0),  // x = 5 ; y = 15
            rgb(252, 139, 0),  // x = 6 ; y = 15
            rgb(126, 70, 0),  // x = 7 ; y = 15
            rgb(126, 70, 0),  // x = 8 ; y = 15
            rgb(126, 70, 0),  // x = 9 ; y = 15
            rgb(252, 139, 0),  // x = 10 ; y = 15
            rgb(252, 139, 0),  // x = 11 ; y = 15
            rgb(252, 139, 0),  // x = 12 ; y = 15
            rgb(252, 139, 0),  // x = 13 ; y = 15
            rgb(2, 175, 69),  // x = 14 ; y = 15
            rgb(2, 175, 69)  // x = 15 ; y = 15
          }
};


const  Img_t house = {  &house_mat[0][0],      // data matrix
                 16,      // width
                 16};     // height
                 

void demo1();
void demo2();
void demo3();
void demo4();
void demo5();



void setup() {
  Serial.begin(9600);
  panel.setBrightness(30);
}

void loop() {

  panel.image(house, 0, 0);
  panel.show();
}


void demo1(){
  panel.setPixel(rgb(100, 0, 0));
  panel.show();
  delay(100);

  panel.setPixel(rgb(0, 100, 0));
  panel.show();
  delay(100);

  panel.setPixel(rgb(0, 0, 100));
  panel.show();
  delay(100);

  panel.clear();
  panel.show();
  delay(100);
}

void demo2(){
    panel.setPixel(rgb(255, 255, 255));
    panel.show();
    panel.setBrightness(random(0, 64));  
}

void demo3(){
      for(int x=0; x<W; x++)
          for(int y=0; y<H; y++){
              panel.setPixel(x, y, rgb(random(0, 255), random(0, 255), random(0, 255)));
              panel.show();
              delay(100);
          }         
 }

void demo4(){
      for(int x=0; x<W; x++)
          for(int y=0; y<H; y++){
              panel.setPixel(x, y, rgb(random(0, 255), random(0, 255), random(0, 255)));
              panel.show();
              delay(100);
              panel.clear();
          }         
 }

void demo5(){
      panel.setBrightness(255);
      panel.setPixel(rgb(random(0, 255), random(0, 255), random(0, 255)));
      panel.show();
      delay(20);
      panel.clear();
      panel.setPixel(rgb(0, 0, 0));
      panel.show();
      delay(20);
 }


 
